#include<bits/stdc++.h>
using namespace std;
long long n,m,a,b,c,d,brkrompira,brpolja,niz[50005];
int main(){
   cin>>n>>m;
   cin>>a>>b;
   for(int i=1;i<=m;i++){
      cin>>c>>d;
      if(d>=a){
         niz[i]=min(b,d);
         brkrompira+=niz[i];
         brpolja++;
      }
   }
   cout<<brkrompira<<endl;
   cout<<brpolja<<endl;
   for(int i=1;i<=m;i++){
      if(niz[i]>0){
      cout<<1<<" "<<i<<" "<<niz[i]<<endl;
      }
   }
return 0;
}